unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Types, Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  FPImage, FPCanvas, Ellipses, IntfGraphics, LazCanvas;

type

  { TForm1 }

  TForm1 = class(TForm)
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
  private
    procedure CreateImage;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

procedure Draw_Ellipse(ACanvas: TFPCustomCanvas;
  aLeft,aTop,aRight,aBottom: Longint; AColor: TFPColor);
var
  bounds: TRect;
  info: TEllipseInfo;
  InfoData: PEllipseInfoData;
  x,y: Longint;
  c: dword;
  r: Longint;
begin
  bounds.Left:=aLeft;
  bounds.Top:=aTop;
  bounds.Right:=aRight;
  bounds.Bottom:=aBottom;

  // Umrandung zeichnen
  info := TEllipseInfo.Create;
  try
    // ElliseInfoRecords erzeugen
    info.GatherEllipseInfo (bounds);

    // Alle Pixel von links nach rechts durchlaufen
    for x := aLeft to aRight do  // warum bis x?
    begin
       // Eintrag der InfoList zum aktuellen Pixel bei x holen
       info.GetInfoForX(x, InfoData);
       with InfoData^ do
       begin
         // Die Pixel des oberen Ellipsenrandes bei x zeichnen, von oben nach unten
         info.GetInfoForX(x,InfoData);
         for y := InfoData^.ytopmin to InfoData^.ytopmax do
           ACanvas.Colors[x, y] := AColor;
//           vipgfx.PutPixelClip (vscreen, x,y, c);    //aus vipgfx Paket von Kirill Kranz
         // Genauso die Pixel des unteren Ellipsenrandes zeichnen
         for y := InfoData^.ybotmin to InfoData^.ybotmax do
           ACanvas.Colors[x, y] := AColor;
//           vipgfx.PutPixelClip (vscreen, x,y, c);   //auf vipgfx Paket von Kirill Kranz
       end;
     end;

    //aus Ellipses unit von fclimage, zusätzlich um zu sehen ob es mit den Original FPC Units klappt
    // Um beide Ellipsen zu sehen versetze ich die FCL-Image Ellipse um 2 px nach rehts unten
    OffsetRect(bounds, 2, 2);
    DrawSolidEllipse(ACanvas, bounds, colBlack);

   finally
     info.Free;
   end;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  CreateImage;
end;

procedure TForm1.CreateImage;
var
  bmp: TBitmap;         // LCL image Klasse
  img: TLazIntfImage;   // von FPCustomImage abgeleitet
  canv: TLazCanvas;
begin
  bmp := TBitmap.Create;
  try
    bmp.SetSize(200, 200);
    img := bmp.CreateIntfImage;
    try
      canv := TLazCanvas.Create(img);
      try
        canv.Brush.FPColor := colWhite;
        canv.FillRect(0, 0, img.Width, img.Height);

        Draw_Ellipse(canv, 10, 10, 190, 90, colRed);

        bmp.LoadFromIntfImage(img);
        Image1.Picture.Bitmap.Assign(bmp);
      finally
        canv.Free;
      end;
    finally
      img.Free;
    end;
  finally
    bmp.Free;
  end;
end;

end.

